#include "demo.i"

		.global	m_balls

getsin:
		; Inputs:
		;	r16	factor
		;	r17	offset
		;	r23:r22	frame
		;	r31	hi8(sine)
		; Output:
		;	r16

		fmul	r22, r16
		mov	r30, r1
		fmul	r23, r16
		add	r30, r0
		add	r30, r17
		lpm	r16, Z
		ret

prepare:
		ldi	r16, 223
		mov	r17, r25
		rcall	getsin
		asr	r16
		st	Y+, r16

		movw	r16, r26
		rcall	getsin
		asr	r16
		st	Y+, r16

		ldi	r16, 223
		mov	r17, r25
		subi	r17, 256-64
		rcall	getsin
		subi	r16, 128
		swap	r16
		andi	r16, 0x0f
		st	Y+, r16

		subi	r25, 85
		ret

ball:
		ld	r16, Y+
		sub	r16, r24
		fmuls	r16, r16
		mov	r30, r1

		ld	r16, Y+
		sub	r16, r25
		fmuls	r16, r16
		add	r30, r1		; [0, 255]

		ld	r16, Y+
		add	r30, r16
		brcs	2f
		cpi	r30, 32
		brlo	1f
2:
		ldi	r30, 31
1:
		lsl	r30
		lpm	r16, Z
		lsr	r16
		sub	r21, r16

		ret

m_balls:
		ldi	r31, hi8(sine)

		in	r22, GPIOR1
		in	r23, GPIOR2

		ldi	r25, 0

		ldi	r26, 155
		ldi	r27, 83
		rcall	prepare

		ldi	r26, 68
		ldi	r27, 10
		rcall	prepare

		ldi	r26, 100
		ldi	r27, 200
		rcall	prepare

		ldi	r26, 0x00
		ldi	r27, 0x02
		sbic	GPIOR0, GFLAG_DBLBUF
		ldi	r26, 0x80
		sbic	GPIOR0, GFLAG_DBLBUF
		ldi	r27, 0x03

		ldi	r20, 1
		ldi	r25, 0xc0
yloop:
		ldi	r24, 0xa0
xloop:
		ldi	r21, 0xc0

		ldi	r28, lo8(scratch)
		rcall	ball
		rcall	ball
		rcall	ball

		lsl	r21
		brcs	2f
		lsl	r21
		brcs	2f

		lsl	r21
3:		rol	r20
		lsl	r21
		rol	r20

		brcc	1f
		st	X+, r20
		ldi	r20, 1
1:
		subi	r24, 256-4
		cpi	r24, 0x60
		brne	xloop

		subi	r25, 256-4
		cpi	r25, 0x40
		brne	yloop

		ret
2:
		ldi	r21, 0xff
		rjmp	3b
