#include "demo.i"

		.global	l_column

l_column:
		DE64				;			t246

		ldi	r31, hi8(sine)		;		1

		in	r30, GPIOR1		;		1
		lpm	r18, Z			;		3
		asr	r18			;		1
		subi	r18, 128		;		1
		mul	r19, r18		;		2
		sub	r30, r1			;		1

		ldi	r22, 0x43		;		1
		ldi	r23, 0x54		;		1

		mov	r0, r23			;		1
		mov	r1, r22			;		1
		sbrc	r30, 6			;		\_ 2
		movw	r22, r0			;		/
		andi	r30, 63			;		1

		subi	r30, 256-32		;		1

		lpm	r24, Z			; [0, 127]	3
		subi	r30, 256-64		;		1
		lpm	r25, Z			; [-128, 127]	3
		mov	r26, r24		;		1
		neg	r26			; [-127, 0]	1

		; r26 <= r25 <= r24

		ldi	r27, 127		;		1
		sub	r27, r24		; [0, 127]	1
		sub	r24, r25		; [0, 255]	1
		sub	r25, r26		; [0, 255]	1
		subi	r26, 128		; [0, 127]	1

		; r27 + r24 + r25 + r26 = 127 - o24 + o24 + o25 - o25 + o26 - o26 + 128 = 255

		; Shrink r24 and r25, add to r27 and r26 to compensate.

		in	r30, GPIOR1		;		1
		sub	r30, r19		;		1
		lpm	r16, Z			;		3
		subi	r16, 128		;		1

		mul	r24, r16		;		2
		rcall	resize			;		12
		sub	r24, r1			;		1

		mul	r25, r16		;		2
		rcall	resize			;		12
		sub	r25, r1			;		1

1:						; t378				\_ 776
		subi	r27, 1			;		\_ 3 * r27 + 2	|
		brcc	1b			;		/		|
						;				|
		out	PORTD, r22		; 		1		|
2:						;				|
		subi	r24, 1			;		\_ 3 * r24 + 2	|
		brcc	2b			;		/		|
						;				|
		out	PORTD, r23		; 		1		|
3:						;				|
		subi	r25, 1			;		\_ 3 * r25 + 2	|
		brcc	3b			;		/		|
						;				|
		out	PORTD, r2		; 		1		|
4:						;				|
		subi	r26, 1			;		\_ 3 * r26 + 2	|
		brcc	4b			;		/		/

		rjmp	endofline		; t19

resize:		; 3 + 9
		lsr	r1			;		1
		lsr	r1			;		1
		add	r27, r1			;		1
		add	r26, r1			;		1
		lsl	r1			;		1
		ret				;		4

