#include "demo.i"

		.global	initplasma
		.global	l_plasma

initplasma:
		push	r28
		push	r29

		ldi	r28, 0
		ldi	r29, 0x03
		ldi	r30, 0
		ldi	r31, hi8(sine)

		ldi	r20, 0x43
		ldi	r22, 0x11
		ldi	r26, 0
		ldi	r27, 0x02
		ldi	r21, 255
1:
		subi	r21, 14
		brcc	2f
		add	r20, r22
2:
		lpm	r16, Z+
		asr	r16
		st	Y+, r16

		st	X+, r20

		cpi	r26, 0x80
		brne	3f
		neg	r22
3:
		tst	r26
		brne	1b

		ldi	r16, 100		; prepare labyrinth parameters
		sts	scratch+9, r16
		mov	r14, r16

		pop	r29
		pop	r28
		ret

l_plasma:
		DE97				; t246

		ldi	r31, hi8(sine)		; 1
		ldi	r29, 0x03		; 1
		ldi	r27, 0x02		; 1
		in	r17, GPIOR1		; 1
		lsl	r17			; 1

		mov	r30, r15		; 1
		add	r30, r17		; 1
		lpm	r16, Z			; 3

		ldi	r23, 7			; 1
		muls	r16, r23		; 2
		mov	r22, r0			; 1
		add	r23, r1			; 1

		mov	r30, r19		; 1
		com	r30			; 1
		lsr	r30			; 1
		sub	r30, r17		; 1
		lpm	r28, Z			; 3
		ld	r21, Y			; 2
		sub	r21, r17		; 1

		ldi	r18, 256-34		; 1
		mulsu	r18, r22		; 2
		mov	r20, r0			; 1
		mov	r28, r1			; 1
		mulsu	r18, r23		; 2
		add	r28, r0			; 1
		add	r28, r17		; 1

		ldi	r18, 69			; 1
1:
		add	r20, r22		; 1
		adc	r28, r23		; 1
		ld	r26, Y			; 2
		add	r26, r21		; 1
		ld	r16, X			; 2
		out	PORTD, r16		; 1	t385 (+12n)
		subi	r18, 1			; 1
		brne	1b			; 1/2

		DE8				;	t1
		out	PORTD, r2		; 1	t9
		DE9
		rjmp	endofline		; 2	t19
