#include "demo.i"

		.global	l_rotozoom

l_rotozoom:

		DE86				; t246

		; Put direction vector in r17, r18

		ldi	r31, hi8(sine)		;				1

		in	r30, GPIOR1		;				1
		lsl	r30			;				1
		lpm	r20, Z			;				3
		asr	r20			;				1
		asr	r20			;				1
		asr	r20			;				1
		subi	r20, 256-40		; [24, 55]			1

		in	r30, GPIOR1		;				1
		lpm	r17, Z			;				3
		mulsu	r17, r20		;				2
		mov	r17, r1			;				1
		subi	r30, 256-64		;				1
		lpm	r18, Z			;				3
		mulsu	r18, r20		;				2
		mov	r18, r1			;				1

		; Put initial coordinate in r20, r21 (ycoord * rot(dir) - 35 * dir)
		; (=> ix = -dy * line - 35 * dx, iy = dx * line - 35 * dy)

		mov	r22, r19		;				1
		subi	r22, 128		;				1
		ldi	r16, 40			;				1
		mulsu	r22, r16		;				2
		mov	r22, r1			;				1

		muls	r18, r22		; dy * line			2
		mov	r20, r0			;				1
		neg	r20			;				1
		muls	r17, r22		; dx * line			2
		mov	r21, r0			;				1
		ldi	r22, 35			;				1
		muls	r17, r22		; dx * 35			2
		sub	r20, r0			;				1
		muls	r18, r22		; dy * 35			2
		sub	r21, r0			;				1

		add	r21, r30		;				1
		add	r21, r30		;				1
		add	r21, r30		;				1

		; Prepare colours

		ldi	r22, 0x33		;				1
		;ldi	r23, 0x33 ^ 0x55	;				1
		;sbic	GPIOR0, GFLAG_COLOUR	;				\_ 2
		ldi	r23, 0x33 ^ 0x34	;				/

		ldi	r24, 69			;				1
1:
		mov	r16, r22		; t382 (+11n)			\_ 11
		add	r20, r17		;				|
		sbrc	r20, 7			;				|
		eor	r16, r23		;				|
		add	r21, r18		;				|
		sbrc	r21, 7			;				|
		eor	r16, r23		;				|
		out	PORTD, r16		; t389 (+11n)			|
		subi	r24, 1			;				|
		brne	1b			;				/ (-1)

		rjmp	de6bde5end		; t5
