#include "demo.i"
#include "generated.i"

		.global	m_greets
		.global	greetstable
		.global	greetstable_end

m_greets:
		sbic	GPIOR0, GFLAG_INIT_GREETS
		rjmp	1f
0:
		sbi	GPIOR0, GFLAG_INIT_GREETS
		ldi	r30, lo8(greetstable)
		ldi	r31, hi8(greetstable)
		movw	r14, r30
		st	Y, r3
1:
		movw	r30, r14
		cpi	r30, lo8(greetstable_end)
		breq	0b
1:
		mov	r0, r3

		ldi	r20, 1
		ldi	r21, 0
		ld	r24, Y
		subi	r24, 0x40
		brcc	2f
		ldi	r20, 0
		ldi	r21, 19*5
2:
		st	Y, r24
		lpm	r18, Z+
		movw	r14, r30

		ldi	r28, 0x08
		ldi	r29, 0x02
3:
		subi	r18, 0x20
		brcs	4f
		adiw	r28, 19*2
		adiw	r28, 19*3
		rjmp	3b
4:
		andi	r18, 31
charloop:
		movw	r26, r28
		rcall	gettile

		ldi	r22, 0x99
		ldi	r23, 0xa8
		movw	r26, r28
		rcall	waitvbl
		rcall	puttile

		add	r18, r20
		add	r28, r21
		adc	r29, r3

		cpi	r17, TILE_BLANK
		breq	9f
		cpi	r29, 5
		breq	9f
		cpi	r18, 19
		breq	9f

		cpi	r17, TILE_NBSP
		breq	8f

		inc	r0
		sbrc	r0, 0
		rcall	decay
8:
		rjmp	charloop
9:
		ret

decay:
		push	r18

		ldi	r26, 0x08
		ldi	r27, 0x02
4:
		movw	r0, r26
		ldi	r18, 0
6:
		rcall	gettile
		cpi	r22, 0x55
		brlo	7f

		subi	r22, 0x11
		subi	r23, 0x11
		movw	r26, r0
		rcall	puttile
7:
		movw	r26, r0
		inc	r18
		cpi	r18, 19
		brne	6b

		adiw	r26, 3*19
		adiw	r26, 2*19
		cpi	r27, 5
		brne	4b

		ldi	r16, 5
5:
		rcall	waitvbl
		subi	r16, 1
		brne	5b

		pop	r18
		ret

#define COORD(x, y) (((y) << 5) + (x))

greetstable:
		.byte	COORD(3, 5)	; down		tbc
		.byte	COORD(11, 5)	; across	noice
		.byte	COORD(0, 1)	; across	romeo k
		.byte	COORD(2, 3)	; across	splendence
		.byte	COORD(7, 2)	; down		adhoc
		.byte	COORD(11, 4)	; across	nature
		.byte	COORD(11, 2)	; across	traktor
		.byte	COORD(1, 5)	; across	fit
		.byte	COORD(15, 0)	; down		outbreak
		.byte	COORD(5, 0)	; across	fairlight
		.byte	COORD(15, 7)	; across	kryo
		.byte	COORD(2, 2)	; across	rrrola
		.byte	COORD(13, 0)	; down		traction
		.byte	COORD(9, 1)	; across	farbrausch
		.byte	COORD(0, 4)	; across	asd
		.byte	COORD(5, 5)	; across	moods
		.byte	COORD(18, 5)	; down		jco
		.byte	COORD(3, 6)	; across	b p crew
		.byte	COORD(1, 0)	; across	mfx
		.byte	COORD(0, 7)	; across	ukscene all*
		.byte	COORD(0, 1)	; down		rgba
greetstable_end:
		.byte	0
