#include "demo.i"

	; Variable budget (0x100-0x17f):
	;	Interrupt state machine, sync	  3 bytes
	;	Copper & wipe parameters	 13 bytes
	;	Effect parameters		  2 bytes
	;	Scratch area			 10 bytes
	;	Story & vectors			  7 bytes
	;	SFX channel data		 63 bytes
	;	SFX globals			  6 bytes
	; -----------------------------------------------
	;					104 bytes

	; Stack budget (0x180-0x1ff):
	;	Interrupt handler:
	;		Saved registers:	 23 bytes
	;		Allowed call depth:	  4 words
	;	Vblank pseudo-interrupt:
	;		Saved registers:	 23 bytes
	;		Allowed call depth:	  6 words
	;	Main program:
	;		Allowed call depth:	 20 words
	; -----------------------------------------------
	;					106 bytes


		.section	.bss

		.comm		syncline, 1
		.comm		intskip, 1
		.comm		intnext, 1

		.comm		coppertime, 12, 1
		.comm		copperfield, 1

		.comm		yscroll, 1
		.comm		spokes, 1

		.comm		scratch, 10, 1

		.comm		vblvector, 1
		.comm		mainvector, 1
		.comm		storywait, 2, 1
		;.comm		gfxptr, 2
		.comm		gfxbits, 1

		.comm		ch, 3*c_sz, 1

		.comm		noisevol, 1
		;.comm		songptr, 2
		.comm		songbits, 1
		.comm		tracktimer, 1
		.comm		trackpos, 1
