#include "demo.i"

		.global	v_grow0
		.global	v_enterpic
		.global	v_exitpic
		.global	v_movecube

#define BLINDHEIGHT 32

	; Frame number is available in r17:r16
	; Y points to coppertime array

v_enterpic:
		ldd	r30, Y+cl_pic
		subi	r30, 256-1
		brmi	9f

		rcall	commonpic

		;inc	r16		; todo remove?
		std	Y+0, r16	; height of upper offset block

		lsr	r17
		std	Y+1, r17	; height of lower offset block
9:
		ret

v_exitpic:
		ldd	r30, Y+cl_pic
		subi	r30, 1
		brcs	9f

		rcall	commonpic

		ldi	r18, 64
		sub	r18, r16
		std	Y+1, r18	; height of lower offset block

		neg	r19
		std	Y+0, r19	; height of upper offset block
9:
		ret

commonpic:
		std	Y+cl_pic, r30

		ldi	r31, hi8(sine)

		lpm	r16, Z		; r16 smoothly goes from 0 to 127 to 3
		lsr	r16

		subi	r30, 64
		lpm	r17, Z
		subi	r17, 0x80	; r17 smoothly goes from 1 to 255
		mov	r19, r17
		lsr	r17
		inc	r17
		std	Y+3, r17	; height of tile field [1, 128]

		ret

nextcolour:
		adiw	r28, 1
v_movecube:
		;sbi	GPIOR0, GFLAG_SPOKEANIM
		ldd	r17, Y+cl_xoffs
		inc	r17
		sbrc	r16, 0
		sbrc	r16, 1
		std	Y+cl_xoffs, r17
		breq	nextcolour
		ret

v_grow0:
		ld	r16, Y
		tst	r16
		breq	9f

		subi	r16, 256-0x04
		brcs	1f
		ldi	r16, 0
1:
		st	Y, r16
9:
		ret

